#include "common.h"

class pondering{
      public:

      pondering(hashtable &hashtableInput, board &rootInit, EGTBProbe* egtb);
      ~pondering();
      void start();
      void run();
      void stop();
      
      private:

      searchtree s;
      unsigned long* m_hThread;
      int ponderingEnabled;
      board& root;
      
		// Thread priorities
		static const int P_ABOVE_NORMAL;
		static const int P_BELOW_NORMAL;
		static const int P_HIGHEST;
		static const int P_IDLE;
		static const int P_LOWEST;
		static const int P_NORMAL;
		static const int P_CRITICAL;

};
