#include "common.h"

class searchtree{
      public:
      timer timer1;
	  killerMoveTable kmt;

      searchtree(hashtable &hashtableInput, EGTBProbe* initegtb);
      searchtree(hashtable &hashtableInput, int &enabledInit, EGTBProbe* initegtb);
      ~searchtree();
      MOVE think(board &b, int searchTime, int maxdepth);
      
      //private:
      int alphaBeta(int move, board &parent,  int depth, int alpha, int beta);
      int quiescence(int move, board &parent, int alpha, int beta); 
      int* searchEnabled;
      static hashtable* hashtable1;
      static int normalSearchtree;
      
      int maxDepth;
      //for debugging/speed count/output:
	  void printThinking(board b, MOVE firstMove);
      int nodes;
	  int total_nodes;
	  int total_time;
	  int bestMoveValue;
	  //int ABnodes;
      void printFinalPosition(board &parent);
	  void printFinalPosition(board b, MOVE firstMove);

	  static int analyze;
	  static int iterative;
	  static EGTBProbe* egtb;

};
